		__config _HS_OSC & _WDT_OFF & _PWRTE_ON & _CP_OFF	
		#include<p16f84.inc>
		list	p=16f84

; ZVONOK_M   11
;   . 

int	equ	11	;   5 .
ct0	equ	12	;     .
cnt1	equ	13	;---------------------------------------------------------
cnt2	equ	14	;    
cnt3	equ	15	; .
cnt4	equ	16
cnt5	equ	17	;---------------------------------------------------------
st	equ	18	;    
			;  560 .
adress	equ	19	;   EEPROM .
kont	equ	20	;     .
int_dec	equ	21	; -  .
pamyat	equ	22	;     EEPROM.
;---------------------------------------------------------------------------------
	org	0
	goto	Init	
	org	4	;     RB0 
	goto	nastr	;   .
	retfie
;---------------------------------------------------------------------------------
Init	clrf	PORTA		;   PORTA  
	clrf	PORTB		;PORT   . 
	bsf 	STATUS,RP0	
	movlw	b'00010010'	;RA1  RA4  .
	movwf	TRISA		
	movlw	b'00000001'	;R0  .
	movwf	TRISB
	bcf 	STATUS,RP0
;//////////////////  ./////////////////////////////////////
nastr	bcf	PORTA,0		
	movlw	b'00000000'	;     
	movwf	INTCON		; R0.
	btfss	PORTB,0		;   R0.
	goto	vipol
;---------------------------------------------------------------------------------
	clrf	adress		;  adress.
;---------------      ------------
	bsf	PORTA,3		
	movlw	b'11101110'
	movwf	PORTB
	bcf	PORTA,3
	bsf	PORTA,2
	movlw	b'11101110'
	movwf	PORTB
	bcf	PORTA,2
;---------------------------------------------------------------------------------
	btfss	PORTA,1		;   RA1. 
	goto	nastr
;---------------------------------------------------------------------------------
	movlw	.176	;  176 (880 .-.  
	movwf	st	;   11   80 .)  st.
plus_1	call	sh_brk		
	incf	adress,f
;---------------     (12-adress)--------------
	movf	adress,0
	sublw	.13
	movwf	kont	
	decfsz	kont,0
	goto	int_CLR
	movf	st,w
	movwf	pamyat
	goto	write_st
;---------------   OK-------------------------------------
ind_ok	bsf	PORTA,3
	movlw	b'01000010'	;"K".
	movwf	PORTB
	call	break
	bcf	PORTA,3
	bsf	PORTA,2
	movlw	b'00010000'	;"O".
	movwf	PORTB
	call	break
	bcf	PORTA,2
;---------------------------------------------------------------------------------
	btfss	PORTB,0
	goto	nastr
	btfss	PORTA,1
	goto	ind_ok
	goto	nastr
;---------------   -----------------------------
int_CLR	clrf	int
	clrf	int_dec
;---------------     RA4  RA1.-------------
prov	btfsc	PORTA,4
	goto	plus
	btfss	PORTA,1
	goto	ind_tm
	movf	int,w
	movwf	pamyat
	goto	write_int
;---------------    ( )------------------
ind_tm	bsf	PORTA,3
	movf	int_dec,w
	andlw	0F
	call	Tab
	movwf	PORTB
	call	break		
	bcf	PORTA,3	
        
        bsf	PORTA,2
  	swapf	int_dec,w
	andlw	0F
	call	Tab
	movwf	PORTB
	call	break		
	bcf	PORTA,2	
	goto	prov

Tab	addwf	PCL,f
	retlw	b'00010000'	;0
	retlw	b'11011010'	;1
	retlw	b'00101000'	;2
	retlw	b'10001000'	;3
	retlw	b'11000010'	;4
	retlw	b'10000100'	;5
	retlw	b'00000100'	;6
	retlw	b'11011000'	;7
	retlw	b'00000000'	;8
	retlw	b'10000000'	;9
		
;---------------    .------------------
plus	call	sh_brk
	incf	int,f
	movlw	.5
	addwf	int_dec,f
;---------------     HEX  DEC.------------------------
	movf	int_dec,w	;  int_dec   (w).
	andlw	0F		;     .
	sublw	0B		;  (w-0B).
	movwf	kont		; w   kont. 
	decfsz	kont,0		;  (kont-1).
	goto	s		;       
				; . 
	movlw	.6		;   0,    
	addwf	int_dec,f	; int_dec  6  		
				;  .
;---------------     (17-int)-----------------
s	movf	int,0
	sublw	.18
	movwf	kont	
	decfsz	kont,0
	goto	minus
;---------------------------------------------------------------------------------
	clrf	int
	clrf	int_dec
	movlw	.16
	addwf	st,f
	goto	ind_tm
;---------------------------------------------------------------------------------
minus	decf	st,f
	goto	ind_tm
;---------------    EEPROM   16 (80 .)--------
write_int
	movf	int,0
	sublw	.17
	movwf	kont
	decfsz	kont,0
	goto	write_st	
	movlw	.16
	movwf	pamyat
;---------------------------------------------------------------------------------
write_st
	bcf	INTCON,GIE
	bsf	STATUS,RP0
	btfsc	EECON1,WR
	goto	$-1
;---------------------------------------------------------------------------------
	bcf	STATUS,RP0
	movfw	adress
	movwf	EEADR
	movfw	pamyat
	movwf	EEDATA
	bsf 	STATUS,RP0
	bsf	EECON1,WREN
;_________________________________________________________________________________
	movlw	0x55
	movwf	EECON2
	movlw	0xAA
	movwf	EECON2
	bsf	EECON1,WR	
;_________________________________________________________________________________			
	bcf	EECON1,WREN
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
	bcf STATUS,RP0
	movf	adress,0
	sublw	.13
	movwf	kont
	decfsz	kont,0
	goto	plus_1
	goto	ind_ok
;-------------  150---------------------------------------------------
sh_brk	movlw   .200	;200	
	movwf   cnt1 
z1	movlw   .255	;255
	movwf   cnt2      
z2	decfsz  cnt2, f
	goto    z2 
	decfsz  cnt1, f
	goto    z1
	return
;-------------  10----------------------------------------------------       
break	movlw   .137	;137
	movwf   cnt1 
t1	movlw   .21	;21
	movwf   cnt2      
t2	decfsz  cnt2, f
	goto    t2 
	decfsz  cnt1, f
	goto    t1
	return
;---------------------------------------------------------------------------------
;/////////////// ./////////////////////////////////////////////////
vipol	movlw	b'10010000'	;    	
	movwf	INTCON		;  RB0. 
;---------------------------------------------------------------------------------
	clrf	adress
	clrf	ct0
;---------------------------------------------------------------------------------
v_plus	incf	adress,f
;---------------     (12-adress)--------------
	movf	adress,0
	sublw	.13
	movwf	kont
	decfsz	kont,0
	goto	read_int
;---------------------------------------------------------------------------------
	bsf	PORTA,0		;. .	
	call	break_7s
	bcf	PORTA,0		;. .
;---------------------------------------------------------------------------------
	call	read		
	call	break_4m53s
;---------------------------------------------------------------------------------
	movlw	.112		;   5 
	movwf	ct0		; ct0.
	call	break_5m
	goto	vipol
;---------------------------------------------------------------------------------
read_int
	call	read
	incf	ct0,f
	decfsz	ct0,f
	goto	preriv
	goto	v_plus
;---------------------------------------------------------------------------------
preriv	bsf	PORTA,0
	call	break_7s
	bcf	PORTA,0
;---------------------------------------------------------------------------------
	call	break_4m53s
	goto	v_plus
;---------------------------------------------------------------------------------
read	movfw	adress
	movwf	EEADR
	bsf	STATUS,RP0
	bsf	EECON1,RD
	bcf	STATUS,RP0
	movf	EEDATA,W
	movwf	ct0
	return
;------------  7 .---------------------------------------------------
;_______________t=[(3y+4)x+85]z+3______________;7000002 
break_7s
	movlw   .227	;227
	movwf   cnt3 
a1	movlw   .248	;248
	movwf   cnt2
;--------------(8*X+9)=81---------------------------------------------------------
	movlw   .9
	movwf   cnt4
	nop
	nop
	nop
	nop
	nop
	nop
v	call	v1
	decfsz  cnt4, f
	goto    v 
	goto    a2
v1	nop
	return
;---------------------------------------------------------------------------------
a2	movlw   .40	;40
	movwf   cnt1
a3	decfsz  cnt1, f
	goto    a3 
	decfsz  cnt2, f
	goto    a2
	decfsz  cnt3, f
	goto    a1
	return
;_________________________________________________________________________________

;-----------  4  53 .-----------------------------------------------
;_______________t=[[(3y+4)x+26]z+4]a+3_____________;292976787 
break_4m53s
	movlw   .248	;248
	movwf   cnt4
c1	movlw   .254	;254
	movwf   cnt3
c2	movlw   .185	;185
	movwf   cnt2
;--------------(8*X+6)=22---------------------------------------------------------
	movlw   .2
	movwf   cnt5
	nop
	nop
	nop
x	call	x1
	decfsz  cnt5, f
	goto    x 
	goto    c3
x1	nop
	return
;---------------------------------------------------------------------------------
c3	movlw   .7	;7
	movwf   cnt1
c4	decfsz  cnt1, f
	goto    c4 
	decfsz  cnt2, f
	goto    c3
	decfsz  cnt3, f
	goto    c2
	decfsz  cnt4, f
	goto    c1
;_________________________________________________________________________________
	decfsz	ct0,f
	goto	break_5m
	return
;-----------  5 .----------------------------------------------------
;_______________t=[[(3y+4)x+25]z+4]a+3_____________;300000419 
break_5m
	movlw   .254	;254
	movwf   cnt4
b1	movlw   .254	;254
	movwf   cnt3
b2	movlw   .185	;185
	movwf   cnt2
;--------------(8*X+5)=21---------------------------------------------------------
	movlw   .2
	movwf   cnt5
	nop
	nop
y	call	y1
	decfsz  cnt5, f
	goto    y 
	goto    b3
y1	nop
	return
;---------------------------------------------------------------------------------
b3	movlw   .7	;7
	movwf   cnt1
b4	decfsz  cnt1, f
	goto    b4 
	decfsz  cnt2, f
	goto    b3
	decfsz  cnt3, f
	goto    b2
	decfsz  cnt4, f
	goto    b1
;_________________________________________________________________________________
	decfsz	ct0,f
	goto	break_5m
	return
;/////////////////////////////////////////////////////////////////////////////////
	end


